/*--------------------------------------------------
	=============== Autorun File ===============
	*** Copyright (c) 2012-2017 by DrVrej, All rights reserved. ***
	No parts of this code or any of its contents may be reproduced, copied, modified or adapted,
	without the prior written consent of the author, unless otherwise indicated for stand-alone materials.
--------------------------------------------------*/
------------------ Addon Information ------------------
local PublicAddonName = "Dark Messiah SNPCs"
local AddonName = "Dark Messiah"
local AddonType = "SNPC"
local AutorunFile = "autorun/vj_dms_autorun.lua"
-------------------------------------------------------
local VJExists = file.Exists("lua/autorun/vj_base_autorun.lua","GAME")
if VJExists == true then
	include('autorun/vj_controls.lua')

	local vCat = "Dark Messiah"

	VJ.AddNPC("Spider Queen","npc_vj_dmvj_spider_queen",vCat)
	VJ.AddNPC("Spider","npc_vj_dmvj_spider",vCat)
	VJ.AddNPC("Giant Worm","npc_vj_dmvj_giant_worm",vCat)
	VJ.AddNPC("FaceHugger","npc_vj_dmvj_facehugger",vCat)

	-- Precache Models --


	-- ConVars --
	VJ.AddConVar("vj_dm_spiderqueen_h",10000)
	VJ.AddConVar("vj_dm_spiderqueen_d_single",85)
	VJ.AddConVar("vj_dm_spiderqueen_d_dual",47)
	VJ.AddConVar("vj_dm_spiderqueen_d_poison",96)

	VJ.AddConVar("vj_dm_spider_h",200)
	VJ.AddConVar("vj_dm_spider_d_reg",30)
	VJ.AddConVar("vj_dm_spider_d_slow",37)
	VJ.AddConVar("vj_dm_spider_d_slowdual",21)

	VJ.AddConVar("vj_dm_facehugger_h",100)
	VJ.AddConVar("vj_dm_facehugger_d_reg",25)
	VJ.AddConVar("vj_dm_facehugger_d_bite",30)
	VJ.AddConVar("vj_dm_facehugger_d_slow",38)

	VJ.AddConVar("vj_dm_worm_h",8000)
	VJ.AddConVar("vj_dm_worm_d",80)
	
	-- Menu --
	local AddConvars = {}
	AddConvars["vj_dm_nobabyspawn"] = 1 -- Spawn Baby Spiders?
	AddConvars["vj_dm_nextbaby"] = 40 -- Next Baby Spawn
	AddConvars["vj_dm_babyspawnlimit"] = 9 -- Baby spawn limit
	for k, v in pairs(AddConvars) do
		if !ConVarExists( k ) then CreateConVar( k, v, {FCVAR_ARCHIVE} ) end
	end

	if (CLIENT) then
	local function VJ_DMMENU_MAIN(Panel)
		if !game.SinglePlayer() then
		if !LocalPlayer():IsAdmin() or !LocalPlayer():IsSuperAdmin() then
			Panel:AddControl( "Label", {Text = "You are not an admin!"})
			Panel:ControlHelp("Notice: Only admins can change this settings.")
			return
			end
		end
		Panel:AddControl( "Label", {Text = "Notice: Only admins can change this settings."})
		local vj_dmreset = {Options = {}, CVars = {}, Label = "Reset Everything:", MenuButton = "0"}
		vj_dmreset.Options["#vjbase.menugeneral.default"] = { 
		vj_dm_nobabyspawn = "1",
		vj_dm_nextbaby = "40",
		vj_dm_babyspawnlimit = "9",
		}
		Panel:AddControl("ComboBox", vj_dmreset)
		Panel:AddControl("Checkbox", {Label = "Spawn Baby Spiders?", Command = "vj_dm_nobabyspawn"})
		Panel:ControlHelp("Should Spider Queen Spawn baby spiders or not?")
		Panel:AddControl("Slider",{Label = "Baby Spider Limit",min = 3,max = 99,Command = "vj_dm_babyspawnlimit"})
		Panel:ControlHelp("How many baby spiders are allowed at a time?")
		Panel:ControlHelp("This is rounded to the nearest or lowest multiple of 3!")
		Panel:AddControl("Slider",{Label = "Next Baby Spider Spawn",min = 0,max = 300,Command = "vj_dm_nextbaby"})
		Panel:ControlHelp("How much time until Spider Queen can spawn baby spiders again?")
		Panel:ControlHelp("Total of 300 seconds (5 Minutes)")
	end
	function VJ_ADDTOMENU_DM()
		spawnmenu.AddToolMenuOption( "DrVrej", "SNPC Configures", "Dark Messiah", "Dark Messiah", "", "", VJ_DMMENU_MAIN, {} )
	end
		hook.Add( "PopulateToolMenu", "VJ_ADDTOMENU_DM", VJ_ADDTOMENU_DM )
	end
-- !!!!!! DON'T TOUCH ANYTHING BELOW THIS !!!!!! -------------------------------------------------------------------------------------------------------------------------
	AddCSLuaFile(AutorunFile)
	VJ.AddAddonProperty(AddonName,AddonType)
else
	if (CLIENT) then
		chat.AddText(Color(0,200,200),PublicAddonName,
		Color(0,255,0)," was unable to install, you are missing ",
		Color(255,100,0),"VJ Base!")
	end
	timer.Simple(1,function()
		if not VJF then
			if (CLIENT) then
				VJF = vgui.Create("DFrame")
				VJF:SetTitle("ERROR!")
				VJF:SetSize(790,560)
				VJF:SetPos((ScrW()-VJF:GetWide())/2,(ScrH()-VJF:GetTall())/2)
				VJF:MakePopup()
				VJF.Paint = function()
					draw.RoundedBox(8,0,0,VJF:GetWide(),VJF:GetTall(),Color(200,0,0,150))
				end
				
				local VJURL = vgui.Create("DHTML",VJF)
				VJURL:SetPos(VJF:GetWide()*0.005, VJF:GetTall()*0.03)
				VJURL:Dock(FILL)
				VJURL:SetAllowLua(true)
				VJURL:OpenURL("https://sites.google.com/site/vrejgaming/vjbasemissing")
			elseif (SERVER) then
				timer.Create("VJBASEMissing",5,0,function() print("VJ Base is Missing! Download it from the workshop!") end)
			end
		end
	end)
end