AddCSLuaFile("shared.lua")
include('shared.lua')
/*-----------------------------------------------
	*** Copyright (c) 2012-2017 by DrVrej, All rights reserved. ***
	No parts of this code or any of its contents may be reproduced, copied, modified or adapted,
	without the prior written consent of the author, unless otherwise indicated for stand-alone materials.
-----------------------------------------------*/
ENT.Model = {"models/VJ_AS/boomer.mdl"} -- The game will pick a random model from the table when the SNPC is spawned | Add as many as you want
ENT.StartHealth = GetConVarNumber("vj_as_boomer_h")
ENT.HullType = HULL_MEDIUM_TALL
---------------------------------------------------------------------------------------------------------------------------------------------
ENT.VJ_NPC_Class = {"CLASS_ALIENSWARM"} -- NPCs with the same class with be allied to each other
ENT.BloodColor = "Yellow" -- The blood type, this will determine what it should use (decal, particle, etc.)
ENT.HasMeleeAttack = true -- Should the SNPC have a melee attack?
ENT.AnimTbl_MeleeAttack = {ACT_MELEE_ATTACK1} -- Melee Attack Animations
ENT.MeleeAttackAnimationDecreaseLengthAmount = 0.5 -- This will decrease the time until starts chasing again. Use it to fix animation pauses until it chases the enemy.
ENT.MeleeAttackDistance = 55 -- How close does it have to be until it attacks?
ENT.MeleeAttackDamageDistance = 145 -- How far does the damage go?
ENT.TimeUntilMeleeAttackDamage = 0.5 -- This counted in seconds | This calculates the time until it hits something
ENT.NextAnyAttackTime_Melee = 0.5 -- How much time until it can use any attack again? | Counted in Seconds
ENT.MeleeAttackDamage = GetConVarNumber("vj_as_boomer_d_push")
ENT.FootStepTimeRun = 0.3 -- Next foot step sound when it is running
ENT.FootStepTimeWalk = 0.7 -- Next foot step sound when it is walking
ENT.HasMeleeAttackKnockBack = true -- If true, it will cause a knockback to its enemy
ENT.MeleeAttackKnockBack_Forward1 = 270 -- How far it will push you forward | First in math.random
ENT.MeleeAttackKnockBack_Forward2 = 300 -- How far it will push you forward | Second in math.random
ENT.MeleeAttackKnockBack_Up1 = 250 -- How far it will push you up | First in math.random
ENT.MeleeAttackKnockBack_Up2 = 260 -- How far it will push you up | Second in math.random
ENT.GibOnDeathDamagesTable = {"All"} -- Damages that it gibs from | "UseDefault" = Uses default damage types | "All" = Gib from any damage
ENT.HasExtraMeleeAttackSounds = true -- Set to true to use the extra melee attack sounds
	-- ====== Sound File Paths ====== --
-- Leave blank if you don't want any sounds to play
ENT.SoundTbl_FootStep = {"boomer/footstep01.wav","boomer/footstep02.wav","boomer/footstep03.wav","boomer/footstep04.wav"}
ENT.SoundTbl_Idle = {"boomer/inflate.wav","boomer/roar02.wav"}
ENT.SoundTbl_Alert = {"boomer/roar01.wav","boomer/alert01.wav"}
ENT.SoundTbl_MeleeAttack = {"boomer/attack01.wav","boomer/attack02.wav"}
ENT.SoundTbl_MeleeAttackMiss = {"boomer/swipe01.wav","boomer/swipe02.wav","boomer/swipe03.wav"}
ENT.SoundTbl_Pain = {"boomer/land02.wav"}
ENT.SoundTbl_Death = {"boomer/boomer_bomb01.wav","boomer/boomer_bomb02.wav","boomer/boomer_bomb03.wav","boomer/boomer_bomb04.wav"}
---------------------------------------------------------------------------------------------------------------------------------------------
function ENT:CustomOnInitialize()
	//self:SetCollisionBounds(Vector(40, 50, 100), Vector(-40, -50, 0))
	self:SetCollisionBounds(Vector(50, 50, 120), Vector(-50, -50, 0))

	self.SackLight = ents.Create("light_dynamic")
	self.SackLight:SetKeyValue("_light","147 112 219 200")
	self.SackLight:SetKeyValue("brightness","0")
	self.SackLight:SetKeyValue("distance","250")
	self.SackLight:SetKeyValue("style","0")
	self.SackLight:SetPos(self:GetPos())
	self.SackLight:SetParent(self)
	self.SackLight:Fire("SetParentAttachment","eyes")
	self.SackLight:Spawn()
	self.SackLight:Activate()
	self.SackLight:Fire("TurnOn","",0)
	self:DeleteOnRemove(self.SackLight)
end
---------------------------------------------------------------------------------------------------------------------------------------------
function ENT:MultipleMeleeAttacks()
	local randattack = math.random(1,2)
	if randattack == 1 then
		self.AnimTbl_MeleeAttack = {"vjseq_melee_02b"}
		self.TimeUntilMeleeAttackDamage = 0.9
		self.NextAnyAttackTime_Melee = 0.55
		self.MeleeAttackDamage = GetConVarNumber("vj_as_boomer_d_push")
		self.HasMeleeAttackKnockBack = true
		self.MeleeAttackKnockBack_Forward1 = 270
		self.MeleeAttackKnockBack_Forward2 = 300
		self.MeleeAttackKnockBack_Up1 = 250
		self.MeleeAttackKnockBack_Up2 = 260
		self.SoundTbl_MeleeAttackMiss = {"boomer/attack01.wav","boomer/attack02.wav"}
	elseif randattack == 2 then
		self.AnimTbl_MeleeAttack = {"vjseq_melee_03"}
		self.TimeUntilMeleeAttackDamage = 0.7
		self.NextAnyAttackTime_Melee = 0.5
		self.MeleeAttackDamage = GetConVarNumber("vj_as_boomer_d_stomp")
		self.HasMeleeAttackKnockBack = false
		self.SoundTbl_MeleeAttackMiss = {"boomer/dronehitheavy01.wav"}
	end
end
---------------------------------------------------------------------------------------------------------------------------------------------
function ENT:SetUpGibesOnDeath(dmginfo,hitgroup)
	util.BlastDamage(self,self,self:GetPos(),300,60)
	util.ScreenShake(self:GetPos(), 100, 200, 1, 2500)
	if self.HasGibDeathParticles == true then
		local bloodeffect = EffectData()
		bloodeffect:SetOrigin(self:GetPos() +self:OBBCenter())
		bloodeffect:SetColor(VJ_Color2Byte(Color(255,221,35)))
		bloodeffect:SetScale(150)
		util.Effect("VJ_Blood1",bloodeffect)
		
		local bloodspray = EffectData()
		bloodspray:SetOrigin(self:GetPos() +self:OBBCenter())
		bloodspray:SetScale(10)
		bloodspray:SetFlags(3)
		bloodspray:SetColor(1)
		util.Effect("bloodspray",bloodspray)
		util.Effect("bloodspray",bloodspray)
		
		local effectdata = EffectData()
		effectdata:SetOrigin(self:GetPos() +self:OBBCenter())
		effectdata:SetScale(1.3)
		util.Effect("StriderBlood",effectdata)
		util.Effect("StriderBlood",effectdata)
		ParticleEffect("antlion_gib_02", self:GetPos(), Angle(0,0,0), nil)
	end
	self:CreateGibEntity("prop_ragdoll","models/aliens/boomer/boomerlega.mdl",{Pos=self:GetPos()+self:GetUp()*95,Ang=self:GetAngles()+Angle(0,200,0),Vel=self:GetForward()*-math.Rand(450,550)}) -- Back Leg
	self:CreateGibEntity("prop_ragdoll","models/aliens/boomer/boomerlegb.mdl",{Pos=self:GetPos()+self:GetUp()*95+self:GetRight()*-10,Ang=self:GetAngles()+Angle(0,30,0),Vel=self:GetRight()*-math.Rand(450,550)}) -- Right Leg
	self:CreateGibEntity("prop_ragdoll","models/aliens/boomer/boomerlegc.mdl",{Pos=self:GetPos()+self:GetUp()*95+self:GetRight()*15,Ang=self:GetAngles()+Angle(0,-30,0),Vel=self:GetRight()*math.Rand(450,550)}) -- Left Leg
	self:CreateGibEntity("obj_vj_gib","UseAlien_Small")
	self:CreateGibEntity("obj_vj_gib","UseAlien_Small")
	self:CreateGibEntity("obj_vj_gib","UseAlien_Small")
	self:CreateGibEntity("obj_vj_gib","UseAlien_Small")
	self:CreateGibEntity("obj_vj_gib","UseAlien_Small")
	self:CreateGibEntity("obj_vj_gib","UseAlien_Small")
	self:CreateGibEntity("obj_vj_gib","UseAlien_Small")
	self:CreateGibEntity("obj_vj_gib","UseAlien_Small")
	self:CreateGibEntity("obj_vj_gib","UseAlien_Big")
	self:CreateGibEntity("obj_vj_gib","UseAlien_Big")
	self:CreateGibEntity("obj_vj_gib","UseAlien_Big")
	self:CreateGibEntity("obj_vj_gib","UseAlien_Big")
	self:CreateGibEntity("obj_vj_gib","UseAlien_Big")
	self:CreateGibEntity("obj_vj_gib","UseAlien_Big")
	self:CreateGibEntity("obj_vj_gib","UseAlien_Big")
	self:CreateGibEntity("obj_vj_gib","UseAlien_Big")
	return true
end
/*-----------------------------------------------
	*** Copyright (c) 2012-2017 by DrVrej, All rights reserved. ***
	No parts of this code or any of its contents may be reproduced, copied, modified or adapted,
	without the prior written consent of the author, unless otherwise indicated for stand-alone materials.
-----------------------------------------------*/