AddCSLuaFile("shared.lua")
include('shared.lua')
/*-----------------------------------------------
	*** Copyright (c) 2012-2017 by DrVrej, All rights reserved. ***
	No parts of this code or any of its contents may be reproduced, copied, modified or adapted,
	without the prior written consent of the author, unless otherwise indicated for stand-alone materials.
-----------------------------------------------*/
ENT.Model = {"models/VJ_AS/drone.mdl"} -- The game will pick a random model from the table when the SNPC is spawned | Add as many as you want
ENT.StartHealth = GetConVarNumber("vj_as_drone_h")
ENT.HullType = HULL_MEDIUM
---------------------------------------------------------------------------------------------------------------------------------------------
ENT.VJ_NPC_Class = {"CLASS_ALIENSWARM"} -- NPCs with the same class with be allied to each other
ENT.BloodColor = "Yellow" -- The blood type, this will determine what it should use (decal, particle, etc.)
ENT.HasMeleeAttack = true -- Should the SNPC have a melee attack?
ENT.AnimTbl_MeleeAttack = {ACT_MELEE_ATTACK1} -- Melee Attack Animations
ENT.MeleeAttackDistance = 48 -- How close does it have to be until it attacks?
ENT.MeleeAttackDamageDistance = 100 -- How far does the damage go?
ENT.TimeUntilMeleeAttackDamage = 0.4 -- This counted in seconds | This calculates the time until it hits something
ENT.NextAnyAttackTime_Melee = 0.6 -- How much time until it can use any attack again? | Counted in Seconds
ENT.MeleeAttackDamage = GetConVarNumber("vj_as_drone_d")
ENT.HasDeathBodyGroup = true -- Set to true if you want to put a bodygroup when it dies
	-- Doing it in custom initialize instead
//ENT.CustomBodyGroup = true -- Set true if you want to set custom bodygroup
//ENT.DeathBodyGroupA = 0 -- Used for Custom Bodygroup | Group = A
//ENT.DeathBodyGroupB = 2 -- Used for Custom Bodygroup | Group = B
ENT.HasExtraMeleeAttackSounds = true -- Set to true to use the extra melee attack sounds
ENT.FootStepTimeRun = 0.3 -- Next foot step sound when it is running
ENT.FootStepTimeWalk = 0.3 -- Next foot step sound when it is walking
ENT.MeleeAttackBleedEnemy = true -- Should the player bleed when attacked by melee
ENT.MeleeAttackBleedEnemyChance = 3 -- How chance there is that the play will bleed? | 1 = always
ENT.MeleeAttackBleedEnemyDamage = 1 -- How much damage will the enemy get on every rep?
ENT.MeleeAttackBleedEnemyTime = 1 -- How much time until the next rep?
ENT.MeleeAttackBleedEnemyReps = 4 -- How many reps?
ENT.AnimTbl_CallForHelp = {"roar"} -- Call For Help Animations
ENT.CallForHelpStopAnimationsTime = 2 -- How long should it stop attacks?
ENT.PoseParameterLooking_InvertPitch = true -- Inverts the pitch poseparameters (X)
ENT.PoseParameterLooking_InvertYaw = true -- Inverts the yaw poseparameters (Y)
	-- ====== Sound File Paths ====== --
-- Leave blank if you don't want any sounds to play
ENT.SoundTbl_FootStep = {"drone/footstep1a.wav","drone/footstep1b.wav"}
ENT.SoundTbl_Idle = {"drone/glide01.wav","drone/glide02.wav","drone/glide03.wav","drone/roar01.wav","drone/roar02.wav"}
ENT.SoundTbl_Alert = {"drone/alert01.wav","drone/alert02.wav","drone/alert03.wav"}
ENT.SoundTbl_MeleeAttack = {"drone/attack01.wav","drone/attack02.wav","drone/attack03.wav","drone/attack04.wav"}
ENT.SoundTbl_MeleeAttackMiss = {"drone/swipe01.wav","drone/swipe02.wav","drone/swipe03.wav"}
ENT.SoundTbl_Pain = {"drone/pain01.wav","drone/pain02.wav","drone/pain03.wav","drone/pain04.wav","drone/pain05.wav","drone/pain06.wav"}
ENT.SoundTbl_Death = {"drone/deathfire01.wav","drone/deathfire02.wav","drone/deathfire03.wav","drone/deathfire04.wav","drone/death01.wav"}

ENT.FootStepSoundLevel = 55
---------------------------------------------------------------------------------------------------------------------------------------------
function ENT:CustomOnInitialize()
	self:SetCollisionBounds(Vector(25, 25, 70), Vector(-25, -25, 0))
	self:SetBodygroup(1,math.random(0,2))
	self:SetBodygroup(2,math.random(0,2))
	self:SetBodygroup(3,math.random(0,2))
	self:SetBodygroup(4,math.random(0,2))
	if math.random(1,6) == 1 then self:SetBodygroup(5,1) end
	if math.random(1,6) == 1 then
		self:SetBodygroup(0,1)
	else
		if math.random(1,2) == 1 then self.CustomBodyGroup = true self.DeathBodyGroupB = 2 end
	end
	
	if GetConVarNumber("ai_disabled") == 0 && math.random(1,2) == 1 then
		self:SetNoDraw(true)
		VJ_EmitSound(self,{"drone/burrow01.wav","drone/burrow02.wav","drone/burrow03.wav","drone/burrow04.wav"},70,math.random(80,100))
		timer.Simple(0.05,function() if IsValid(self) then self:VJ_ACT_PLAYACTIVITY("burrow_out",true,1.16,true) end end)
		timer.Simple(0.5,function() if IsValid(self) then self:SetNoDraw(false) end end)
	end
end
---------------------------------------------------------------------------------------------------------------------------------------------
function ENT:CustomOnCallForHelp()
	timer.Simple(1,function()
		if IsValid(self) then
			ParticleEffectAttach("antlion_gib_02_gas",PATTACH_POINT_FOLLOW,self,6)
			ParticleEffectAttach("antlion_gib_02_floaters",PATTACH_POINT_FOLLOW,self,6)
		end
	end)
end
/*-----------------------------------------------
	*** Copyright (c) 2012-2017 by DrVrej, All rights reserved. ***
	No parts of this code or any of its contents may be reproduced, copied, modified or adapted,
	without the prior written consent of the author, unless otherwise indicated for stand-alone materials.
-----------------------------------------------*/