AddCSLuaFile("shared.lua")
include('shared.lua')
/*-----------------------------------------------
	*** Copyright (c) 2012-2017 by DrVrej, All rights reserved. ***
	No parts of this code or any of its contents may be reproduced, copied, modified or adapted,
	without the prior written consent of the author, unless otherwise indicated for stand-alone materials.
-----------------------------------------------*/
ENT.Model = {"models/VJ_AS/shieldbug.mdl"} -- The game will pick a random model from the table when the SNPC is spawned | Add as many as you want
ENT.StartHealth = GetConVarNumber("vj_as_shieldbug_h")
ENT.HullType = HULL_LARGE
---------------------------------------------------------------------------------------------------------------------------------------------
ENT.VJ_NPC_Class = {"CLASS_ALIENSWARM"} -- NPCs with the same class with be allied to each other
ENT.BloodColor = "Yellow" -- The blood type, this will determine what it should use (decal, particle, etc.)
ENT.HasBloodPool = false -- Does it have a blood pool?
ENT.HasMeleeAttack = true -- Should the SNPC have a melee attack?
ENT.AnimTbl_MeleeAttack = {ACT_MELEE_ATTACK1,ACT_MELEE_ATTACK2} -- Melee Attack Animations
ENT.MeleeAttackDistance = 64 -- How close does it have to be until it attacks?
ENT.MeleeAttackDamageDistance = 175 -- How does the damage go?\
ENT.TimeUntilMeleeAttackDamage = 0.8 -- This counted in seconds | This calculates the time until it hits something
ENT.NextAnyAttackTime_Melee = 0.5 -- How much time until it can use any attack again? | Counted in Seconds
ENT.MeleeAttackDamage = GetConVarNumber("vj_as_shieldbug_d_reg")
ENT.HasMeleeAttackKnockBack = true -- If true, it will cause a knockback to its enemy
ENT.MeleeAttackKnockBack_Forward1 = 370 -- How far it will push you forward | First in math.random
ENT.MeleeAttackKnockBack_Forward2 = 390 -- How far it will push you forward | Second in math.random
ENT.MeleeAttackKnockBack_Up1 = 50 -- How far it will push you up | First in math.random
ENT.MeleeAttackKnockBack_Up2 = 50 -- How far it will push you up | Second in math.random
ENT.MeleeAttackWorldShakeOnMiss = true -- Should it shake the world when it misses during melee attack?
ENT.MeleeAttackWorldShakeOnMissAmplitude = 16 -- How much the screen will shake | From 1 to 16, 1 = really low 16 = really high
ENT.MeleeAttackWorldShakeOnMissRadius = 1500 -- How far the screen shake goes, in world units
ENT.MeleeAttackWorldShakeOnMissDuration = 0.5 -- How long the screen shake will last, in seconds
ENT.MeleeAttackWorldShakeOnMissFrequency = 100 -- Just leave it to 100
ENT.HasDeathRagdoll = false -- If set to false, it will not spawn the regular ragdoll of the SNPC
ENT.HasDeathAnimation = true -- Does it play an animation when it dies?
ENT.AnimTbl_Death = {"vjseq_die_simple"} -- Death Animations
ENT.DeathAnimationTime = 8 -- Time until the SNPC spawns its corpse and gets removed
ENT.FootStepTimeRun = 0.3 -- Next foot step sound when it is running
ENT.FootStepTimeWalk = 0.3 -- Next foot step sound when it is walking
ENT.HasExtraMeleeAttackSounds = true -- Set to true to use the extra melee attack sounds
ENT.ConstantlyFaceEnemy = true -- Should it face the enemy constantly?
ENT.CustomRunActivites = {ACT_COVER} -- Custom run activities
	-- ====== Sound File Paths ====== --
-- Leave blank if you don't want any sounds to play
ENT.SoundTbl_FootStep = {"shieldbug/default01.wav","shieldbug/default02.wav"}
ENT.SoundTbl_Idle = {"shieldbug/idle01.wav","shieldbug/idle02.wav"}
ENT.SoundTbl_Alert = {}
ENT.SoundTbl_MeleeAttack = {"shieldbug/attack01.wav","shieldbug/attack02.wav","shieldbug/attack03.wav"}
ENT.SoundTbl_MeleeAttackMiss = {"shieldbug/stomp01.wav","shieldbug/stomp02.wav"}
ENT.SoundTbl_Pain = {"shieldbug/pain01.wav","shieldbug/pain02.wav","shieldbug/move_voc03.wav"}
ENT.SoundTbl_Death = {"shieldbug/pain01.wav","shieldbug/pain02.wav"}

-- Custom
ENT.SHIELDBUG_BlockWalking = false
ENT.NextBlockWalkingT = 0
---------------------------------------------------------------------------------------------------------------------------------------------
function ENT:CustomOnInitialize()
	self:SetCollisionBounds(Vector(70, 70, 100), Vector(-70, -70, 0))
end
---------------------------------------------------------------------------------------------------------------------------------------------
function ENT:CustomOnThink_AIEnabled()
	if self.VJ_IsBeingControlled == true then
		self.AnimTbl_Walk = {ACT_RUN}
		self.AnimTbl_Run = {ACT_COVER}
		self.SHIELDBUG_BlockWalking = false
	else
		if self:GetEnemy() == nil then
			self.AnimTbl_Walk = {ACT_WALK}
			self.AnimTbl_Run = {ACT_RUN}
			self.SHIELDBUG_BlockWalking = false
		else
			if self:GetPos():Distance(self:GetEnemy():GetPos()) < 1000 then
				self.SHIELDBUG_BlockWalking = true
				self.FootStepSoundLevel = 60
				self.AnimTbl_Walk = {ACT_COVER}
				self.AnimTbl_Run = {ACT_COVER}
			else
				self.SHIELDBUG_BlockWalking = false
				self.FootStepSoundLevel = 70
				self.AnimTbl_Walk = {ACT_WALK}
				self.AnimTbl_Run = {ACT_RUN}
			end
		end
	end
	if self:GetEnemy() != nil && self.SHIELDBUG_BlockWalking == true && self.VJ_IsBeingControlled == false then
		self.ConstantlyFaceEnemy = true
		self.AnimTbl_IdleStand = {ACT_COWER}
		//self.AnimTbl_MeleeAttack = {"melee_attack_defend","melee_attack_defend1B"} // "melee_attack_defend2"
	else
		self.ConstantlyFaceEnemy = false
		self.AnimTbl_IdleStand = {ACT_IDLE}
		//self.AnimTbl_MeleeAttack = {ACT_MELEE_ATTACK1,ACT_MELEE_ATTACK2}
	end
end
---------------------------------------------------------------------------------------------------------------------------------------------
function ENT:CustomOnAlert()
	if self.VJ_IsBeingControlled == true then return end
	local randanim = math.random(1,2)
	if randanim == 1 then
		self:VJ_ACT_PLAYACTIVITY(ACT_ARM,true,3.7,true)
		self:AlertSoundCode("shieldbug/roar.wav")
		timer.Simple(1.15,function()
			if self:IsValid() then
				util.ScreenShake(self:GetPos(),16,200,0.5,1500)
				if self.HasSounds == true && self.HasAlertSounds == true then
					VJ_EmitSound(self,"shieldbug/stomp01.wav",80,math.random(90,100))
				end
			end
		end)
		timer.Simple(1.48,function()
			if self:IsValid() then
				util.ScreenShake(self:GetPos(),16,200,0.5,1500)
				if self.HasSounds == true && self.HasAlertSounds == true then
					VJ_EmitSound(self,"shieldbug/stomp02.wav",80,math.random(90,100))
				end
			end
		end)
		timer.Simple(1.88,function()
			if self:IsValid() then
				util.ScreenShake(self:GetPos(),16,200,0.5,1500)
				if self.HasSounds == true && self.HasAlertSounds == true then
					VJ_EmitSound(self,"shieldbug/stomp01.wav",80,math.random(90,100))
				end
			end
		end)
	elseif randanim == 2 then
		self:AlertSoundCode({"shieldbug/alert.wav","shieldbug/move_voc01.wav","shieldbug/move_voc02.wav"})
	end
end
-- Normal: "vjseq_melee_attack1" "vjseq_melee_attack1B" "vjseq_melee_attack2"
-- Defend: "vjseq_melee_attack_defend" "vjseq_melee_attack_defend1B" "vjseq_melee_attack_defend2"
---------------------------------------------------------------------------------------------------------------------------------------------
function ENT:MultipleMeleeAttacks()
	local randattack = math.random(1,3)
	if randattack == 1 then
		if self.SHIELDBUG_BlockWalking == true then
		self.AnimTbl_MeleeAttack = {"vjseq_melee_attack_defend"} else
		self.AnimTbl_MeleeAttack = {"vjseq_melee_attack1"} end
		self.TimeUntilMeleeAttackDamage = 0.8
		self.NextAnyAttackTime_Melee = 0.4
		self.MeleeAttackDamage = GetConVarNumber("vj_as_shieldbug_d_reg")
		self.MeleeAttackKnockBack_Forward1 = 470
		self.MeleeAttackKnockBack_Forward2 = 490
	elseif randattack == 2 then
		if self.SHIELDBUG_BlockWalking == true then
		self.AnimTbl_MeleeAttack = {"vjseq_melee_attack_defend1B"} else
		self.AnimTbl_MeleeAttack = {"vjseq_melee_attack_1B"} end
		self.TimeUntilMeleeAttackDamage = 0.75
		self.NextAnyAttackTime_Melee = 0.4
		self.MeleeAttackDamage = GetConVarNumber("vj_as_shieldbug_d_reg")
		self.MeleeAttackKnockBack_Forward1 = 470
		self.MeleeAttackKnockBack_Forward2 = 490
	elseif randattack == 3 then
		if self.SHIELDBUG_BlockWalking == true then
		self.AnimTbl_MeleeAttack = {"vjseq_melee_attack_defend2"} else
		self.AnimTbl_MeleeAttack = {"vjseq_melee_attack2"} end
		self.TimeUntilMeleeAttackDamage = 0.6
		self.NextAnyAttackTime_Melee = 0.4
		self.MeleeAttackDamage = GetConVarNumber("vj_as_shieldbug_d_double")
		self.MeleeAttackKnockBack_Forward1 = 970
		self.MeleeAttackKnockBack_Forward2 = 990
	end
end
---------------------------------------------------------------------------------------------------------------------------------------------
function ENT:CustomOnTakeDamage_BeforeDamage(dmginfo,hitgroup)
	if hitgroup == 11 then dmginfo:SetDamage(0) end
end
---------------------------------------------------------------------------------------------------------------------------------------------
function ENT:CustomDeathAnimationCode(dmginfo,hitgroup)
	timer.Simple(2.1,function()
		if IsValid(self) then
			self:SetBodygroup(0,1)
			util.VJ_SphereDamage(self,self,self:GetPos(),160,35,DMG_ACID,true,true)
			self:DeathSoundCode({"shieldbug/shieldbugdeath.wav","shieldbug/shieldbuggibsplat.wav"})
			if self.HasGibDeathParticles == true then
				local attach = self:GetAttachment(self:LookupAttachment("attach_explosion")).Pos
				local bloodspray = EffectData()
				bloodspray:SetOrigin(attach)
				bloodspray:SetScale(10)
				bloodspray:SetFlags(3)
				bloodspray:SetColor(1)
				util.Effect("bloodspray",bloodspray)
				util.Effect("bloodspray",bloodspray)
				local effectdata = EffectData()
				effectdata:SetOrigin(attach)
				effectdata:SetScale(1)
				util.Effect("StriderBlood",effectdata)
				util.Effect("StriderBlood",effectdata)
				ParticleEffect("antlion_gib_02_gas",attach,Angle(0,0,0),nil)
				ParticleEffect("antlion_spit",attach,Angle(0,0,0),nil)
				ParticleEffect("antlion_gib_02",attach,Angle(0,0,0),nil)
			end
		end
	end)
end
/*-----------------------------------------------
	*** Copyright (c) 2012-2017 by DrVrej, All rights reserved. ***
	No parts of this code or any of its contents may be reproduced, copied, modified or adapted,
	without the prior written consent of the author, unless otherwise indicated for stand-alone materials.
-----------------------------------------------*/